<?php

/*
INSERT INTO `bb_config` (
`config_name` ,
`config_value`
)
VALUES (
'nnmclub_login', ''
), (
'nnmclub_pass', ''
);


CREATE TABLE IF NOT EXISTS `nnmclub_forums` (
  `active` tinyint(1) NOT NULL DEFAULT '1',
  `forum_old` varchar(255) NOT NULL,
  `forum_new` int(11) NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `all_forum` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

*/

// ACP Header - START
if (!empty($setmodules))
{
	$module['Mods']['Graber nnm-club.me'] = basename(__FILE__);
	return;
}
require('./pagestart.php');
// ACP Header - END

require(INC_DIR .'class.snoopy.php');
$snoopy = new Snoopy;
$mode = request_var('mode', '');

$return_links = array(
	'index' => '<br /><br />'. sprintf($lang['CLICK_RETURN_ADMIN_INDEX'], '<a href="index.php?pane=right">', '</a>'),
	'config' => '<br /><br />'. sprintf($lang['CLICK_RETURN_CONFIG'], '<a href="admin_nnmclub.php">', '</a>'),
);

// Get allowed for searching forums list
if (!$forums = $datastore->get('cat_forums'))
{
	$datastore->update('cat_forums');
	$forums = $datastore->get('cat_forums');
}
$cat_title_html = $forums['cat_title_html'];
$forum_name_html = $forums['forum_name_html'];

$template->assign_vars(array(
	'ALL_STATUS'         => false,
	'ALL_FORUM'          => false,
));

$check_nnmclub = false;
if(!$check_nnmclub = CACHE('bb_cache')->get('check_nnmclub') && $bb_cfg['nnmclub_login'] && $bb_cfg['nnmclub_pass'])
{
	$submit_url = "http://nnm-club.me/forum/login.php";
	$snoopy->_submit_method = "POST";
	$submit_vars = array (
		'username' => $bb_cfg['nnmclub_login'],
		'password' => $bb_cfg['nnmclub_pass'],
		'login'    => true,
	);
	$snoopy->submit($submit_url, $submit_vars);
    $snoopy->fetch("http://nnm-club.me/");

    if(!preg_match('#logout#', $snoopy->results))
    {
    	$errors[] = 'Скрипт не смог зайти по указанным данным';
    }
    else
	{
		CACHE('bb_cache')->set('check_nnmclub', true);
		$check_nnmclub = true;
    }
}

$template->assign_vars(array(
	'LOGIN'              => $bb_cfg['nnmclub_login'],
	'PASS'               => $bb_cfg['nnmclub_pass'],
	'CHECK'              => $check_nnmclub,
));

$sql = DB()->fetch_rowset("SELECT f.*, u.username, u.user_rank FROM nnmclub_forums f LEFT JOIN ". BB_USERS ." u ON(f.user_id = u.user_id)");
if($sql)
{
	for ($i = (count($sql) - 1); $i >= 0; $i--)
	{
		$row = $sql[$i];
		$template->assign_block_vars('r_f', array(
			'NOMER'     => ($i + 1),
			'CLASS'     => !($i % 2) ? 'row1' : 'row2',
			'FORUM_NEW' => '<a href="'. FORUM_URL . $row['forum_new'] .'">'. $forum_name_html[$row['forum_new']] .'</a>',
			'FORUM_OLD' => $row['forum_old'],
			'USER'      => ($row['user_id']) ? profile_url($row) : 'Bot',
			'MD5'       => md5($row['forum_old']),
			'ALL_FORUM' => $row['all_forum'],
			'ACTIVE'    => $row['active'],
		));
	}
}

if (IS_ADMIN)
{
	$forum_select_mode = 'admin';
}
else
{
	$not_auth_forums_csv = $user->get_not_auth_forums(AUTH_VIEW);
	$forum_select_mode = explode(',', $not_auth_forums_csv);
}

$template->assign_vars(array(
	'FORUM_NEW'    => get_forum_select($forum_select_mode, 'forum_new', 0),
));

$errors = array();

if($mode == 'add_logins')
{
	$login   = (string) request_var('login', '');
	$pass    = (string) request_var('pass', '');

	if(!$login)  $errors[] = 'Вы не указали логин';
	if(!$pass) $errors[] = 'Вы не указали пароль';

    if(!$errors)
    {
	    $snoopy->host = "nnm-club.me";
		$snoopy->agent = "opera";
		$snoopy->rawheaders["Pragma"] = "no-cache";

		$submit_url = "http://nnm-club.me/forum/login.php";
		$snoopy->_submit_method = "POST";
		$submit_vars = array (
			'username' => $login,
			'password' => $pass,
			'login'    => true,
		);
		$snoopy->submit($submit_url, $submit_vars);

        $snoopy->fetch("http://nnm-club.me/");

        if(!preg_match('#logout#', $snoopy->results))
        {
        	$errors[] = 'Скрипт не смог зайти по указанным данным';
        }
		else
		{
			CACHE('check_bb_cache')->set('check_nnmclub', true);
			$check_nnmclub = true;
		}
    }

	if(!$errors)
	{
		bb_update_config(array(
		    'nnmclub_login' => $login,
		    'nnmclub_pass'  => $pass,
	    ));
	}

	$template->assign_vars(array(
		'PAGE_TITLE'         => ($errors) ? 'Ошибка при добавление юзера' : 'Успешно добавлено',
		'ERROR_MESSAGE'      => ($errors) ? join('<br />', array_unique($errors)) : '',
		'LOGIN'              => $login,
		'PASS'               => $pass,
		'CHECK'              => $check_nnmclub,
	));
}
elseif($mode == 'add_forums')
{
    $forum_old  = (string) urldecode(request_var('forum_old', ''));
	$forum_new  = (int) request_var('forum_new', '');
    $user_id    = (string) request_var('user_id', '');
    $all_forum  = (int) request_var('all_forum', 0);

	if(!$forum_old) $errors[] = 'Вы не указали откуда парсить';
	if(!$forum_new) $errors[] = 'Вы не указали куда сохранять';

    if(!$errors)
    {
		if(!preg_match('#nnm-club.me/forum/tracker.php\?f=#', $forum_old))
		{
			$errors[] = 'Неверная ссылка, адрес должен быть такого типа http://nnm-club.me/forum/tracker.php?f=ID_форума,ID_форума';
		}
    }

    if($user_id)
    {
    	$row = get_userdata ($user_id);
    	if(!$row) $errors[] = 'Такого пользователя не существует';
    	else $user_id = $row['user_id'];
    }

    if(!DB()->fetch_row("SELECT forum_old FROM nnmclub_forums WHERE forum_old = '$forum_old'") && !$errors)
	{
		$data = array(
			'forum_old'  => $forum_old,
			'forum_new'  => $forum_new,
			'user_id'    => $user_id,
		    'all_forum'  => $all_forum,
		);
		$sql = DB()->build_array('INSERT', $data);
		DB()->query("INSERT INTO nnmclub_forums $sql");

		message_die(GENERAL_MESSAGE, $lang['CONFIG_UPDATED'] . $return_links['config'] . $return_links['index']);
	}
	elseif(!$errors)
	{
		$errors[] = 'По данной ссылке уже парсятся раздачи';
	}

	$template->assign_vars(array(
		'PAGE_TITLE'         => ($errors) ? 'Ошибка при добавление форума' : 'Успешно добавлено',
		'ERROR_MESSAGE'      => ($errors) ? join('<br />', array_unique($errors)) : '',
		'FORUM_OLD'          => $forum_old,
		'USER'               => $user_id,
		'FORUM_NEW'          => get_forum_select($forum_select_mode, 'forum_new', $forum_new),
		'ALL_FORUM'          => !$all_forum,
	));
}

print_page('admin_nnmclub.tpl', 'admin');