<?php

set_time_limit(0);

if (!defined('BB_ROOT')) die(basename(__FILE__));

require(INC_DIR .'class.snoopy.php');
require(INC_DIR .'functions_torrent.php');
require(INC_DIR .'bbcode.php');
require(INC_DIR .'functions_post.php');

$attach_dir = get_attachments_dir();

$ids = array();
$sql = DB()->fetch_rowset("SELECT id FROM nnmclub_releases");
if($sql)
{
	foreach($sql as $i => $row)
	{
		$ids[$row['id']] = true;
	}
}

$sql = DB()->fetch_rowset("SELECT f.forum_new, f.user_id, r.* FROM nnmclub_releases r, nnmclub_forums f WHERE r.time = 0 AND f.forum_old = r.forum_old AND f.active = 1");
if($sql)
{
	$snoopy = new Snoopy;
	$snoopy->host = "nnm-club.me";
	$snoopy->agent = "opera";
	$snoopy->rawheaders["Pragma"] = "no-cache";

	$submit_url = "http://nnm-club.me/forum/login.php";
	$snoopy->_submit_method = "POST";
	$submit_vars = array (
		'username' => $bb_cfg['nnmclub_login'],
		'password' => $bb_cfg['nnmclub_pass'],
		'login'    => true,
	);
	$snoopy->submit($submit_url, $submit_vars);

	$snoopy->_httpmethod = "GET";

	for($i=0; $i < count($sql); $i++)
	{
		if(empty($sql[$i]['id'])) break;

		$subject = DB()->escape($sql[$i]['title']);

		$snoopy->fetch('http://nnm-club.me/forum/viewtopic.php?t='. $sql[$i]['id']);

		$content = iconv('windows-1251', 'UTF-8', $snoopy->results);

		if(preg_match("#форум временно отключен#siu", $content)) break;

		$message = prepare_message(DB()->escape(nnmclub($content)));

		if ($message)
		{
            $snoopy->submit("http://nnm-club.me/forum/download.php?id=". $sql[$i]['attach_id']);
			$torrent = $snoopy->results;
			$tor     = bdecode($torrent);

            if(!empty($tor['info']))
            {
            	$info_hash     = pack('H*', sha1(bencode($tor['info'])));
            	$info_hash_sql = rtrim(DB()->escape($info_hash), ' ');
				$info_hash_md5 = md5($info_hash);

				if($row = DB()->fetch_row("SELECT topic_id FROM ". BB_BT_TORRENTS ." WHERE info_hash = '$info_hash_sql' LIMIT 1"))
				{
				    DB()->sql_query("UPDATE nnmclub_releases SET time = ". TIMENOW ." WHERE title = '$subject'");
				}
				else
				{
				    $new_name = $info_hash_md5;

				    $file = fopen("$attach_dir/$new_name.torrent", 'w');
					fputs($file, $torrent);
					fclose($file);

					$torfile = array(
						'physical_filename'		=> addslashes("$new_name.torrent"),
						'real_filename'			=> addslashes("nnmclub-{$sql[$i]['id']}"),
						'filesize'				=> (int) filesize("$attach_dir/$new_name.torrent"),
					);

					submit_torrent($subject, $message, $sql[$i]['forum_new'], $torfile, (TIMENOW + $i), $sql[$i]['user_id']);
				}
            }
            else
            {
				DB()->sql_query("UPDATE nnmclub_releases SET time = ". TIMENOW ." WHERE title = '$subject'");
			}
			unset($tor);
		}
		else
		{
			DB()->sql_query("UPDATE nnmclub_releases SET time = ". TIMENOW ." WHERE title = '$subject'");
		}
		unset($snoopy->results);
	}
}
function nnmclub($text)
{
				$pos = strpos($text, '<td colspan="2"><hr /></td>');
				$text = substr($text, $pos);
				$pos = strpos($text, '<!-- //bt -->');
				$text = substr($text, 0, $pos);
                $text = str_replace('<span class="postbody">', '', $text);
                $text = str_replace('<!--/spoiler-body-->', '', $text);
                $text = str_replace('<!--/spoiler-wrap-->', '', $text);
                $text = str_replace('<div class="spoiler-wrap">', '', $text);

				$text = preg_replace('/<img src=".*?" alt=".*?" border="0"\/>/', '', $text);
				$text = str_replace('<hr />', "[hr]", $text);

				$text = preg_replace('/<img style="float: (.*?);.*? src="(.*?)" alt="Image" title="Image" border="0" \/>/', "[img=\\1]\\2[/img]\n", $text);

                $text = preg_replace('/<var class="postImg" title="(.*?)">&#10;<\/var>/', '[img]$1[/img]', $text);
				$text = preg_replace('/<var class="postImg postImgAligned img-(.*?)" title="(.*?)">&#10;<\/var>/', "[img=\\1]\\2[/img]\n", $text);
				$text = str_replace('<span class="post-br"><br /></span>', "\n[br]\n", $text);

				$text = str_replace('<br />', "\n", $text);

				$text = str_replace('<ul>', '[list]', $text);
				$text = str_replace('</ul>', '[/list]', $text);
				$text = str_replace('<ol type="">', '[list]', $text);
				$text = str_replace('</ol>', '[/list]', $text);

				$text = str_replace('<li>', "\n[*]", $text);
				$text = str_replace('</li>', '', $text);
				$text = str_replace('<div class="hide spoiler-wrap">', '', $text);
				$text = str_replace('<center>', "[align=center]", $text);
                $text = str_replace('</center>', "[/align]", $text);

                $text = preg_replace('/<table width="90%" cellspacing="1" cellpadding="3" class="qt".*? class="code">(.*?)<\/td>.*?<\/table>/si', '[code]$1[/code]', $text);

                $text = str_replace('&#039;', "'", $text);
				$text = str_replace('&nbsp;', ' ', $text);
				$text = str_replace('&gt;', '>', $text);
				$text = str_replace('&lt;', '<', $text);

                $text = str_replace('<!--[if lte IE 9]>', '', $text);
                $text = str_replace('<![endif]-->', '', $text);
                $text = str_replace('<![if !IE]>', '', $text);
                $text = str_replace('<![endif]>', '', $text);

                $text = preg_replace('/<table align="top" cellpadding="2" cellspacing="0" class="postbody" border="1" bgcolor="#FFFFFF">([\s\S]*?)<\/table>/', '[code]$1[/code]', $text);
                $text = str_replace('<tr>', '', $text);
                $text = str_replace('</tr>', '', $text);
                $text = str_replace('<td>', '', $text);
                $text = str_replace('</td>', '', $text);

                $text = preg_replace('/<table.*?>/', '', $text);
                $text = preg_replace('/<tr.*?>/', '', $text);
				$text = str_replace('</tr>', '', $text);
				$text = preg_replace('/<td.*?>/', '', $text);
				$text = str_replace('</td>', '', $text);
				$text = str_replace('</table>', '', $text);

			    $text = preg_replace('/<object .*? value="(.*?)">.*?<\/object>/si', '[youtube]$1[/youtube]', $text);

			    //$text = preg_replace('/<a href="(.*?)"><img src="http.*?default.jpg" class="ytlite tit-y" title="YouTube" alt="YouTube"><\/a>/siu', '[youtube]$1[/youtube]', $text);
				//$text = preg_replace('/<a href="(.*?)" class="postLink">(.*?)<\/a>/siu', '[url=$1]$2[/url]', $text);

				for ($i=0; $i<=20; $i++)
				{
                    $text = preg_replace('/<span class="text-glow" style="text-shadow:0px 0px 5px .*?;">([^<]*?)<(?=\/)\/span>/', '$1', $text);
                    $text = preg_replace('/<span style="text-shadow:0px 0px 10px .*?;">([^<]*?)<(?=\/)\/span>/', '$1', $text);
                    $text = preg_replace('/<span style="text-shadow:1px 1px 2px lightgrey;" class="text-shadow"><span style="text-shadow:3px 3px 3px lightgrey;">([^<]*?)<(?=\/)\/span><\/span>/', '$1', $text);
					$text = preg_replace('/<span style="font-weight: bold">([^<]*?)<(?=\/)\/span>/', '[b]$1[/b]', $text);
					$text = preg_replace('/<span style="text-decoration: underline">([^<]*?)<(?=\/)\/span>/', '[u]$1[/u]', $text);
					$text = preg_replace('/<span style="font-style: italic">([^<]*?)<(?=\/)\/span>/', '[i]$1[/i]', $text);
					$text = preg_replace('/<span style="text-decoration: line-through">([^<]*?)<(?=\/)\/span>/', '[s]$1[/s]', $text);
					$text = preg_replace('/<span style="font-size: ([^<]*?)px; line-height: normal">([^<]*?)<(?=\/)\/span>/', "[size=\\1]\\2[/size]", $text);
					$text = preg_replace('/<span style="font-family: ([^<]*?)">([^<]*?)<(?=\/)\/span>/', "[font=\"\\1\"]\\2[/font]", $text);
					$text = preg_replace('/<span style="text-align: ([^<]*?); display: block;">([^<]*?)<(?=\/)\/span>/', "[align=\\1]\n\\2\n[/align]", $text);
                    $text = preg_replace('/<span style="color: ([^<]*?)">([^<]*?)<(?=\/)\/span>/', '[color=$1]$2[/color]', $text);
					$text = preg_replace('/<a href="(.*?)".*?class="postLink">([^<]*?)<(?=\/)\/a>/', '[url=$1]$2[/url]', $text);
					$text = preg_replace('/<a href="(.*?)" class="highslide" onclick=".*?" rel="nofollow">([^<]*?)<(?=\/)\/a>/', '[url=$1]$2[/url]', $text);
					$text = preg_replace('/<a href="(.*?)" target="_blank" rel="nofollow">([^<]*?)<(?=\/)\/a>/', '[url=$1]$2[/url]', $text);
					$text = preg_replace('/<div class="spoiler-body">([^<]*?)<(?=\/)\/div><(?=\/)\/div>/', '[spoiler]$1[/spoiler]', $text);
				    $text = preg_replace('/<div class="hide spoiler-body" title="([^<]*?)">([^<]*?)<(?=\/)\/div><(?=\/)\/div>/', '[spoiler="$1"]$2[/spoiler]', $text);
				    $text = preg_replace('/<div class="spoiler-body" title="([^<]*?)">([^<]*?)<(?=\/)\/div><(?=\/)\/div>/', '[spoiler="$1"]$2[/spoiler]', $text);
				}

				$text = str_replace('[url=/forum', '[url=http://nnm-club.me/forum', $text);
				$text = strip_tags(html_entity_decode($text));
				return $text;
}

function submit_torrent($subject, $message, $forum_id, $torfile, $time, $user_id)
{
	global $lang, $bb_cfg;

    $user_ip = '7f000001';
    if(!$user_id) $user_id = BOT_UID;

    DB()->sql_query("INSERT INTO ". BB_TOPICS ."
		(topic_title, topic_poster, topic_time, forum_id, topic_attachment, topic_dl_type, topic_last_post_time)
		VALUES
		('$subject', $user_id, '$time', $forum_id, '1', '1', '$time')");
	$topic_id = DB()->sql_nextid();

	DB()->sql_query("INSERT INTO ". BB_POSTS ."
		(topic_id, forum_id, poster_id, post_time, poster_ip, post_attachment)
		VALUES
		($topic_id, $forum_id, $user_id, '$time', '$user_ip', '1')");
	$post_id = DB()->sql_nextid();

	DB()->sql_query("UPDATE ". BB_TOPICS ." SET
		topic_first_post_id = $post_id,
		topic_last_post_id = $post_id
		WHERE topic_id = $topic_id");

	DB()->sql_query("INSERT INTO ". BB_POSTS_TEXT ."
		(post_id, post_text)
		VALUES
		($post_id, '$message')");

	add_search_words($post_id, stripslashes($message), stripslashes($subject));

	DB()->sql_query("INSERT INTO ". BB_ATTACHMENTS_DESC ."
		(physical_filename, real_filename, extension, mimetype, filesize, filetime)
		VALUES
		('". $torfile['physical_filename'] ."', '". $torfile['real_filename'] ."', 'torrent', 'application/x-bittorrent', '". $torfile['filesize'] ."', ". $time .")");
	$attach_id = DB()->sql_nextid();

	DB()->sql_query("INSERT INTO ". BB_ATTACHMENTS ."
		(attach_id, post_id, user_id_1)
		VALUES
		($attach_id, $post_id, ". $user_id .")");

    DB()->sql_query("UPDATE ". BB_FORUMS ." SET
		forum_posts = forum_posts + 1,
		forum_last_post_id = $post_id,
		forum_topics = forum_topics + 1
		WHERE forum_id = $forum_id");

	DB()->sql_query("UPDATE nnmclub_releases SET time = ". TIMENOW ." WHERE title = '$subject'");

	tracker_register ($attach_id, '', TOR_APPROVED);
}
